#include <iostream>

class Base {
private:
	int a = 1;
	void f() { std::cout << "Bf\n"; }

protected:
	int b = 2;
	void g() { std::cout << "Bg\n"; }

public:
	int c = 3;
	void h() { std::cout << "Bh\n"; }
	Base() { std::cout << "Base()\n"; }
	~Base() { std::cout << "~Base()\n"; }
};

class Derived : public Base {
	int d = 4;

public:
	Derived() {
		std::cout << "Derived()\n";
		// what happens if we uncomment a?
		std::cout << /* a << */ b << c << d << '\n';
	}

	~Derived() { std::cout << "~Derived()\n"; }

	void do_something() {
		// a = 10;
		b = 20;
		c = 30;
		// f();
		g();
		h();
	}
};

int main() {
	Derived obj;
	obj.do_something();
	obj.h();
	obj.c = 1337;

	Base& ref = obj;
	// ref.do_something();
	ref.h();
}
