#include <iostream>
#include <memory>

class Base {
public:
	Base() { std::cout << "Base()\n"; }
	~Base() { std::cout << "~Base()\n"; }
};

class Derived : public Base {
public:
	Derived() { std::cout << "Derived()\n"; }
	~Derived() { std::cout << "~Derived()\n"; }
};

int main() {
	// what happens and why?
	// how do we fix it?
	Derived d;
	std::unique_ptr<Base> uptr = std::make_unique<Derived>();
}
