#include <memory>
#include <vector>

class Base {
	// virtual ~Base() = default;
};

class Derived : public Base {
	std::vector<int> v;

public:
	Derived()
	    : v(1000) {}
};

int main() {
	// everythings seem OK at first glance, but try running valgrind
	std::unique_ptr<Base> uptr = std::make_unique<Derived>();
	// solution: Base needs a virtual destructor
}
