#include <iostream>

class Animal {
	int m_weight = 0;

public:
	int weight() { return m_weight; }
	virtual ~Animal() = default;
};

class FlyingAnimal : public Animal {
};

class Mammal : public Animal {
};

class Bat : public FlyingAnimal, public Mammal {
};

int main() {
	// the famous diamond problem
	Bat bat;
	std::cout << bat.weight() << '\n';
}
